#include <algorithm>
#include <cmath>
#include <iostream>
#include <sstream>
#include <string>

#include "form.h"
using namespace std;

// Constructor for squares and circles, and constructor by default (from slides): 
// p1 acts as the side length of the square 
// or the radius of the circle
Form::Form(Category c, double x, double y, double p1)  
    :category(c), x(x), y(y)
{
    switch(category)
    {
        case CIRCLE:
        case SQUARE: 
            if(p1 < 0.)
            {
                cout << "Form: incorrect parameter value" << endl;
                exit(EXIT_FAILURE);
            }
            param[0] = p1;
            break;
        default: 
            cout << "Form: incorrect category" << endl;
            exit(EXIT_FAILURE);
    }
}

// Constructor for rectangles (from slides):
// p1 and p2 act as length and width of the rectangle
Form::Form(Category c, double x, double y, double p1, double p2)  
	:category(c), x(x), y(y)
{
    if(category == RECTANGLE)
    { 
        if(p1<0. || p2<0)
        {
            cout << "Form: incorrect parameter value" << endl;
            exit(EXIT_FAILURE);
        }
        param[0] = p1;
        param.push_back(p2);
     }
     else
     {
        cout << "Form: incorrect category" << endl;
        exit(EXIT_FAILURE);
     }
}

// display the basic attributes (from the slides)
void Form::affiche()  
{
    switch(category)
    {
        case CIRCLE: 
            cout << "CIRCLE with center:(" << x << ", " << y 
                 << " ) and radius " << param[0] << endl;
            break;
        case SQUARE: 
            cout << "SQUARE with center:(" << x << ", " << y 
                 << " ) and side " << param[0] << endl;
            break;
        case RECTANGLE: 
            cout << "RECTANGLE with center:(" << x << ", " << y 
                 << " ), width: " << param[0] << " and height: " << param[1] << endl;
            break;
        default: 
            cout << "Form: incorrect category" << endl;
            exit(EXIT_FAILURE);
    }
} 

